/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ryuuji.servlet.curso;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import logica.ExNihilo;
import logica.Search;
import orm.Colegio;

/**
 *
 * @author ryuuji
 */
@WebServlet(name = "CrearCurso", urlPatterns = {"/CrearCurso"})
public class CrearCurso extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        if (request.getParameter("nivel").matches("[1-8]")) {
            int nivel = Integer.parseInt(request.getParameter("nivel"));
            if (request.getParameter("letra").matches("[a-zA-Z]")) {
                String letra = request.getParameter("letra").toUpperCase();
                Colegio colegio = Search.buscarColegio("Colegio San Francisco");
                if (Search.buscarCurso(nivel, letra) == null) {
                    if (colegio != null) {
                        if (ExNihilo.crearCurso(nivel, letra, Search.buscarColegio("Colegio San Francisco"))) {
                            request.getRequestDispatcher("CursosServlet").forward(request, response);
                        } else {
                            request.setAttribute("errorCrear", "A ocurrido un error innesperado");
                            request.getRequestDispatcher("CursosServlet").forward(request, response);
                        }
                    } else {
                        if (ExNihilo.crearColegio("Colegio San Francisco")) {
                            if (ExNihilo.crearCurso(nivel, letra, Search.buscarColegio("Colegio San Francisco"))) {
                                request.getRequestDispatcher("CursosServlet").forward(request, response);
                            } else {
                                request.setAttribute("errorCrear", "A ocurrido un error innesperado");
                                request.getRequestDispatcher("CursosServlet").forward(request, response);
                            }
                        } else {
                            request.setAttribute("errorCrear", "A ocurrido un error innesperado");
                            request.getRequestDispatcher("CursosServlet").forward(request, response);
                        }
                    }
                } else {
                    request.setAttribute("errorCrear", "El curso ya existe");
                    request.getRequestDispatcher("CursosServlet").forward(request, response);
                }
            } else {
                request.setAttribute("errorCrear", "La letra del curso, debe ser una letra");
                request.getRequestDispatcher("CursosServlet").forward(request, response);
            }
        } else {
            request.setAttribute("errorCrear", "El nivel, debe ser un numero entre 1 y 8");
            request.getRequestDispatcher("CursosServlet").forward(request, response);
        }

    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
